package com.bizmatics.mhfire.service.impl;

import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.mhfire.persistence.mapper.SiAeAllMapper;
import com.bizmatics.mhfire.service.SiAeAllService;
import com.bizmatics.mhfire.service.vo.SiAeAllVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author yq
 * @date 2021/5/25 15:29
 */
@Service
public class SiAeAllServiceImpl implements SiAeAllService {

    @Autowired
    private SiAeAllMapper siAeAllMapper;
    @Override
    public List<SiAeAllVO> getAeAllCollect(Date startTime, Date endTime) {
        List<SiAeAllVO> allVoS = new ArrayList<>();
        Map<String, Double> aeAllCollect = siAeAllMapper.selectAeAllCollect(startTime,endTime);
        //获取同比
        startTime.setYear(Integer.parseInt(DateUtils.getYear(startTime)) - 1 -1900);
        endTime.setYear(Integer.parseInt(DateUtils.getYear(endTime)) - 1 -1900);
        Map<String, Double> upAllCollect = siAeAllMapper.selectAeAllCollect(startTime,endTime);
        //获取环比
        startTime.setYear(Integer.parseInt(DateUtils.getYear(startTime)) + 1 - 1900);
        endTime.setYear(Integer.parseInt(DateUtils.getYear(endTime)) + 1 - 1900);
        //获取两个时间天数之差
        int distanceOfTwoDate = DateUtils.getDistanceOfTwoDate(startTime, endTime);
        Date linkEndTime = DateUtils.addDays(startTime, -1);
        Date linkStartTime = DateUtils.addDays(linkEndTime, -distanceOfTwoDate);
        Map<String, Double> linkAllCollect = siAeAllMapper.selectAeAllCollect(linkStartTime,linkEndTime);
        for (String type:aeAllCollect.keySet()) {
            SiAeAllVO siAeAllVO = new SiAeAllVO();
            siAeAllVO.setCheckType(type);
            Double radio = aeAllCollect.get(type);
            siAeAllVO.setNumber(radio.intValue());
            siAeAllVO.setSameRatio(upAllCollect.get(type)/radio);
            siAeAllVO.setLinkRelativeRatio(linkAllCollect.get(type)/radio);
            allVoS.add(siAeAllVO);
        }
        return allVoS;
    }
}
